#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <time.h>
#include <string.h>

#define MAXX 100
#define MAXY 100

void move_scr(void);

int cols, rows, maxpix;

int main(int argc, char *argv[])
{
	int gdriver = VGA, gmode = VGALO, errorcode, i, i1, ex;
	char c;

	ex = 0;
	for ( i = 1; i <= argc; ++i)
		for ( i1 = 0; i1 < strlen(argv[i]); ++i1) {
			c = argv[i][i1];
			if (!(c >= '0' && c <= '9'))
				ex = 1;
		}

	if (argc == 4 && !ex) {
		cols 		= atoi(argv[1]);
		rows  	= atoi(argv[2]);
		maxpix 	= atoi(argv[3]);
	}

	if (!((cols >= 2 && cols <= MAXX) && (rows >= 2 && rows <= MAXY) &&
		(maxpix >= 1 && maxpix <= 15)))
		ex = 1;

	if (ex) {
		printf("\tFalscher Aufruf!\n\tSpuren"
					 "[Spalten(2-%d)] [Zeilen(2-%d)] [MaxPix(1-15)]", MAXX, MAXY);
		exit(1);
	}
	clrscr();
	initgraph(&gdriver, &gmode, "\\BORLANDC\\BGI");

	errorcode = graphresult();
	if (errorcode != grOk)
	{
		printf("Graphics error: %s\n", grapherrormsg(errorcode));
		printf("Press any key to halt:");
		getch();
		exit(1);
	}

	move_scr();

	closegraph();
	return(0);
}

void move_scr(void)
{
	register int i1, i2, i3;
	int i[200], dp[200], rest[200], pg, pxl, stp, dx, x, y, akt_y;

	stp = getmaxy() / rows;
	pxl = getmaxx() / cols;
	rows = getmaxy() / stp;
	cols = getmaxx() / pxl;
	pg = 1;
	randomize();
	for (i1 = 0; i1 < rows; ++i1) {
		i[i1] = 0;
		rest[i1] = i1 % 2;
		dp[i1] = random(maxpix)+1;
	}

	while (!kbhit()) {
		for (i1 = 0; i1 < rows; ++i1)
			rest[i1] = !rest[i1];

		pg = !pg;
		setactivepage(!pg);
		setvisualpage(pg);

		for (i1 = 0; i1 < rows; ++i1) {
			if (i[i1]+dp[i1] < pxl)
				i[i1] += dp[i1];
			else {
				i[i1] = 0;
				dp[i1] = random(maxpix)+1;
			}
			rest[i1] = !rest[i1];
			y = i1 * stp;

			for (i3 = 0; i3 <= cols; ++i3) {
				if ((i3 % 2) == rest[i1])
					setfillstyle(SOLID_FILL, BLACK);
				else
					setfillstyle(SOLID_FILL, LIGHTGRAY);

				switch(i3) {
					case 0:    x = 0;
										 dx = i[i1];
										 break;
					case 1:    dx = pxl;
										 x += i[i1];
										 break;
					default:   if (i3 == cols)
											 dx = pxl - i[i1];
										 else
											 dx = pxl;
										 x += pxl;
				}
				if (i1+1 == rows)
					bar(x, y, x+dx, y+stp-1);
				else
					bar(x, y, x+dx, y+stp);
			}
			if (i[i1]+dp[i1] >= pxl) {
				rest[i1] = !rest[i1];
			}
		}
	}
}